using System;
using System.Numerics;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Input;

using Windows.System;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.rectangle.TranslationTransition = new Vector3Transition();

            this.translateButton1.Click       += translateButton_Click;
            this.translateButton2.Click       += translateButton_Click;
            this.translateButton3.Click       += translateButton_Click;
            this.translationNumberBox.KeyDown += translationNumberBox_KeyDown;
            this.translateButton.Click        += translateButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Translation ѹ ڽ Ű ٿ óϱ - translationNumberBox_KeyDown(sender, e)

        /// <summary>
        /// Translation ѹ ڽ Ű ٿ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void translationNumberBox_KeyDown(object sender, KeyRoutedEventArgs e)
        {
            if(e.Key == VirtualKey.Enter)
            {
                translateButton_Click(null, null);
            }
        }

        #endregion
        #region Translate ư Ŭ óϱ - translateButton_Click(sender, e)

        /// <summary>
        /// Translate ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void translateButton_Click(object sender, RoutedEventArgs e)
        {
            Vector3Transition translationTransition = rectangle.TranslationTransition;

            translationTransition.Components = ((this.translateXCheckBox.IsChecked == true) ? Vector3TransitionComponents.X : 0) |
                                               ((this.translateYCheckBox.IsChecked == true) ? Vector3TransitionComponents.Y : 0) |
                                               ((this.translateZCheckBox.IsChecked == true) ? Vector3TransitionComponents.Z : 0);

            float customValue;

            if(sender != null && (sender as Button).Tag != null)
            {
                customValue = (float)Convert.ToDouble((sender as Button).Tag);
            }
            else
            {
                customValue = NormalizeValue(translationNumberBox);
            }

            this.rectangle.Translation = new Vector3(customValue);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region  ȭϱ - NormalizeValue(numberBox)

        /// <summary>
        ///  ȭϱ
        /// </summary>
        /// <param name="numberBox">ѹ ڽ</param>
        /// <returns></returns>
        private float NormalizeValue(NumberBox numberBox)
        {
            if(double.IsNaN(numberBox.Value))
            {
                numberBox.Value = 0;
            }

            return (float)numberBox.Value;
        }

        #endregion
    }
}